package com.uas.erp.schedular.finance.task;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.uas.erp.schedular.entity.Master;
import com.uas.erp.schedular.task.support.Method;
import com.uas.erp.schedular.util.ContextHolder;
import com.usoft.fin.external.open.api.entity.*;
import com.usoft.fin.external.open.api.protobuf.*;
import com.usoft.sdk.fin.client.CapitalSideSdk;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import com.uas.erp.schedular.task.support.Role;
import com.uas.erp.schedular.task.support.TaskMapping;
import com.usoft.fin.external.open.api.protobuf.GetOfferQuotaInfoListReq;
import com.usoft.fin.external.open.api.protobuf.GetOfferQuotaInfoListResp;
import com.usoft.sdk.fin.utils.ProtoBufUtil;

@Component
@TaskMapping(title = "U智融对接服务", role = Role.SELLER)
public class B2BInformation  extends AbstractTask{
	@Autowired
	private CustInfomationTask custInfomationTask;
	private CapitalSideSdk capitalSideSdk = new CapitalSideSdk("https://finrest.uuzcc.cn", "10050877", "b78d577449b64f56a8a6cf1feeb3fbf5");

	/**
     * 额度申请
     * @throws Exception
     */
	@TaskMapping(title = "额度申请下载", fixedDelay = 30000, method = Method.DOWNLOAD)
    public void getOfferQuotaInfoList() throws Exception {
		List<String> sqls = new ArrayList<>();
		long curt = System.currentTimeMillis();
		int cCount = jdbcTemplate.count("FROM CONFIGS WHERE CALLER = 'sys' AND CODE ='lastLoadQuotaTime'");
		if(cCount == 0){
			jdbcTemplate.execute("Insert into CONFIGS (CODE,TITLE,DATA_TYPE,DATA,CALLER,MULTI,ID,EDITABLE) values " +
					"('lastLoadQuotaTime','上次同步额度申请时间','VARCHAR2','"+curt+"','sys',0,CONFIGS_SEQ.NEXTVAL,1)");
		}
		Object lastTime = jdbcTemplate.getObject("SELECT MAX(DATA) FROM CONFIGS WHERE CALLER = 'sys' AND CODE ='lastLoadQuotaTime'");
		Master currMaster = ContextHolder.getMaster();
    	GetOfferQuotaInfoListReq.Builder req = GetOfferQuotaInfoListReq.newBuilder();
    	req.setCsEnuu(10050877); //req.setCsEnuu(Integer.valueOf(currMaster.getMa_uu().toString()));
		if(lastTime != null){//未配置则取全部数据
			long lt = Long.valueOf(String.valueOf(lastTime));
			System.out.println("lt:"+lt);
			req.setUpdateTime(lt);//获取上次更新时间结束后被更新的单据列表
		}
		GetOfferQuotaInfoListResp resp = capitalSideSdk.getOfferQuotaInfoList(req);
		java.util.List<OfferQuotaInfoRest> restlist = resp.getOfferQuoteInfoList();
		//System.out.println("restlist-size:"+restlist.size());
		List<Map<String, Object>> enUUList = new ArrayList<>();
		for(OfferQuotaInfoRest rest : restlist) {
			Map<String, Object> enMap = new HashMap<>();
			if (rest.getFsEnuu() > 0) {
//				System.out.println("CQ_CODE:" + rest.getCode() + ",STATUS:" + rest.getStatus() +
//						",rest.getCsEnName():" + rest.getCsEnName() + "(" + rest.getCsEnuu() + ")" +
//						",rest.getFsEnName():" + rest.getFsEnName() + "(" + rest.getFsEnuu() + ")");
				sqls.add("MERGE INTO CUSTOMERQUOTA INERP " +
						"	USING ( SELECT nvl(MAX(CQ_ID),-1) CQ_ID," +
						"	MAX((select MAX(CU_CODE) from CUSTOMERINFOR WHERE CU_STATUSCODE <> 'DISABLE' AND NVL(CU_ENUU,0) = "+rest.getFsEnuu()+" )) CU_CODE " +
						"	FROM CustomerQuota WHERE CQ_CODE = '" + rest.getCode() + "' ) ONERP " +
						"	ON (INERP.CQ_ID = ONERP.CQ_ID) " +
						"	WHEN MATCHED THEN " +
						"	UPDATE SET INERP.CQ_UPDATEDATE = SYSDATE,INERP.CQ_UPLOADSTATUS='已上传',INERP.CQ_QUOTATYPE='卖方客户',INERP.CQ_COP='"+currMaster.getMa_user()+"',INERP.CQ_CLASS='卖方客户申请单'," +
						"	INERP.CQ_CUSTCODE = ONERP.CU_CODE," +
						"	INERP.CQ_CUSTUU = " + rest.getFsEnuu() + ",INERP.CQ_CUSTNAME='" + rest.getFsEnName() + "'," +
						"	INERP.CQ_APPLYQUOTA=" + rest.getQuotaAmount()*10000 + ",INERP.CQ_EFFECTDAYS=" + rest.getCredDays() + ",INERP.CQ_LENDRATE=" + rest.getFinanceRate() + "," +
						"	INERP.CQ_ANNUALRATE=" + rest.getOfferRate() + ",INERP.CQ_REPAYMENTMEANS='" + rest.getRepayment() + "'," +
						"	INERP.CQ_AUDITDATE = TO_DATE('" + rest.getCheckerTime() + "','YYYY-MM-DD hh24:mi:ss')," +
						"	INERP.CQ_STATUSCODE='" + (rest.getStatus() == 1402 ? "AUDITED" : "ENTERING") + "'," +
						"	INERP.CQ_STATUS='" + (rest.getStatus() == 1402 ? "已审核" : "在录入") + "'," +
						"	INERP.CQ_BASICEVALUATION='" + rest.getCheckerContent() + "'" +
						"	WHEN NOT MATCHED THEN " +
						"	INSERT (CQ_ID,CQ_UPLOADSTATUS,CQ_SOURCETYPE,CQ_QUOTATYPE,CQ_UPDATEDATE,CQ_COP,CQ_CLASS," +
						"	CQ_CODE,CQ_FACTORUU,CQ_FACTORNAME,CQ_CUSTCODE,CQ_CUSTUU,CQ_CUSTNAME," +
						"	CQ_APPLYQUOTA,CQ_EFFECTDAYS,CQ_LENDRATE,CQ_ANNUALRATE,CQ_REPAYMENTMEANS," +
						"	CQ_INDATE,CQ_RECORDER,CQ_RECORDERUU,CQ_AUDITDATE," +
						"	CQ_STATUSCODE,CQ_STATUS,CQ_BASICEVALUATION)" +
						"	VALUES(CUSTOMERQUOTA_SEQ.NEXTVAL,'待上传','B2B','卖方客户',SYSDATE,'"+ currMaster.getMa_user()+"','卖方客户申请单'," +
						"	'" + rest.getCode() + "'," + rest.getCsEnuu() + ",'" + rest.getCsEnName() + "',ONERP.CU_CODE," + rest.getFsEnuu() + ",'" + rest.getFsEnName() + "'," +
						"	" + rest.getQuotaAmount()*10000 + "," + rest.getCredDays() + "," + rest.getFinanceRate() + "," + rest.getOfferRate() + ",'" + rest.getRepayment() + "'," +
						"	TO_DATE('" + rest.getApplyTime() + "','YYYY-MM-DD hh24:mi:ss'),'" + rest.getApplyUsername() + "'," + rest.getApplyUu() + ",TO_DATE('" + rest.getCheckerTime() + "','YYYY-MM-DD hh24:mi:ss')," +
						"	'" + (rest.getStatus() == 1402 ? "AUDITED" : "ENTERING") + "','" + (rest.getStatus() == 1402 ? "已审核" : "在录入") + "','" + rest.getCheckerContent() + "')");
				enMap.put("CQ_CODE",rest.getCode());
				enMap.put("CQ_CUSTUU", rest.getFsEnuu());
				enMap.put("CQ_FACTORUU", rest.getCsEnuu());
				enMap.put("CQ_RECORDERUU", rest.getApplyUu());
				if (!enUUList.contains(enMap)) {
					enUUList.add(enMap);
				}
			}
		}
        //System.out.println(sqls);
		if(cCount > 0){
			//记录本次抓取时间
			sqls.add("UPDATE CONFIGS SET DATA = '"+curt+"' WHERE CALLER = 'sys' AND CODE ='lastLoadQuotaTime'");
		}
		jdbcTemplate.batchExecute(sqls);
		//下载或更新客户信息
		if(enUUList.size()>0){
			custInfomationTask.getCustInfomation(enUUList);
		}
    }

	/**
		* 上传放款信息
		* @throws Exception
		*/
	/*@TaskMapping(title = "上传放款信息", fixedDelay = 30000, method = Method.UPLOAD)
	public void addCapitalSideLoan() throws Exception  {
		   
		    List<Map<String, Object>> capitalSideLoan = getAccountApplyUpload();  //获取需要上传的放款申请
		    AddCapitalSideLoanReq.Builder req = AddCapitalSideLoanReq.newBuilder();
		    OpenCapitalSideLoanOther.Builder capitalSideLoanOther = OpenCapitalSideLoanOther.newBuilder();
		    if (!CollectionUtils.isEmpty(capitalSideLoan)) {
	            List<String> sqlList = new ArrayList<>();
				for (Map<String, Object> map:capitalSideLoan) {
					 capitalSideLoanOther.setFinanceDemandCode(map.get("AA_FINANCEDEMANDCODE").toString());
					 Object loancode = map.get("AA_LOANCODE");
					 if(loancode != null){
						 capitalSideLoanOther.setLoanCode(map.get("AA_LOANCODE").toString());  //放款编号
					 }
					 
					 SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
						Object aa_recedate = map.get("AA_RECEIVABLESARRIVALDATE");
						//String aaredate = format.format(new Date());
						if (aa_recedate!=null){
							capitalSideLoanOther.setReceivablesArrivalDate(map.get("AA_RECEIVABLESARRIVALDATE").toString());
						}
					  if(Double.valueOf(map.get("AA_FINANCERATE").toString()) != null && Double.valueOf(map.get("AA_FINANCERATE").toString()) != 0){
						  capitalSideLoanOther.setFinanceRate(Double.valueOf(map.get("AA_FINANCERATE").toString()));   //融资比例
					  }
					  if(map.get("AA_LOANAMOUNT") !=null){
					      capitalSideLoanOther.setLoanAmount(Double.valueOf(map.get("AA_LOANAMOUNT").toString()));    //放款金额（元）
					    }
					  if(map.get("AA_LOANRATE") != null){
						  capitalSideLoanOther.setLoanDate(map.get("AA_LOANRATE").toString());   //放款日期
					  }
					  if(map.get("AA_BACKDATE") != null){
						  capitalSideLoanOther.setRepaymentData(map.get("AA_BACKDATE").toString());  //还款日期
					  }
					  if(map.get("AA_LOANRATE") != null){
						  capitalSideLoanOther.setLoanRate(Double.valueOf(map.get("AA_LOANRATE").toString()));    //放款年利率
					  }
					  if(map.get("AA_REPAYMENTFREQUENCY") != null){
						  capitalSideLoanOther.setRepaymentFrequency(map.get("AA_REPAYMENTFREQUENCY").toString());   //还息频率
					  }
					   if(map.get("AA_FSCOLLECTIONBANK") != null){
						   capitalSideLoanOther.setFsCollectionBank(map.get("AA_FSCOLLECTIONBANK").toString());    //客户收款开户行
					   }
					    if(map.get("AA_FSCOLLECTIONACCOUNT") != null){
					    	capitalSideLoanOther.setFsCollectionAccount(map.get("AA_FSCOLLECTIONACCOUNT").toString());   //客户收款账号
					    }
					  if(map.get("AA_FSCOLLECTIONNAME") != null){
						  capitalSideLoanOther.setFsCollectionName(map.get("AA_FSCOLLECTIONNAME").toString());   //客户收款账号名称
					  }
					  if(map.get("AA_RECEIPTFORLOAN") != null){
						  capitalSideLoanOther.setReceiptForLoan(Double.valueOf(map.get("AA_RECEIPTFORLOAN").toString()));  //借据余额（元）
					  }
					  if(map.get("AA_INTERESTPAYABLE") != null){
						  capitalSideLoanOther.setInterestPayable(Double.valueOf(map.get("AA_INTERESTPAYABLE").toString()));   //应还利息（元)
					  }
					  if(map.get("AA_BEOVERDUE") != null){
						  capitalSideLoanOther.setBeOverdue(Integer.valueOf(map.get("AA_BEOVERDUE").toString()));   //是否结清
					  }
					  if(map.get("AA_SETTLE") != null ){
						  capitalSideLoanOther.setSettle(Integer.valueOf(map.get("AA_SETTLE").toString()));   //是否结清
				      }
					  if(map.get("AA_APPLYDATE") != null ){
						  capitalSideLoanOther.setApplyDate(map.get("AA_APPLYDATE").toString());   //申请日期
					  } 
					  if(map.get("AA_PERSONINCHARGE") != null){
						  capitalSideLoanOther.setPersonInCharge(map.get("AA_PERSONINCHARGE").toString());   //状态

					  }
					   if(map.get("AA_B2BSTATUS") != null ){
						   capitalSideLoanOther.setStatus(Integer.valueOf(map.get("AA_B2BSTATUS").toString()));  //状态

					   }
					  if(map.get("AA_APPROVALDATE") != null ){
						  capitalSideLoanOther.setApprovalDate(map.get("AA_APPROVALDATE").toString());  //审批人
					  }
					  if(map.get("AA_APPROVALMAN") != null){
						  capitalSideLoanOther.setApprovalMan(map.get("AA_APPROVALMAN").toString()); //审批人
					  }
					  OpenCapitalSideRepaymentPlanOther.Builder capitalSideRepaymentPlanOther = OpenCapitalSideRepaymentPlanOther.newBuilder();
					    capitalSideRepaymentPlanOther.setRepaymentData("2020-2-25");
					    capitalSideRepaymentPlanOther.setCurrency("RMB");
					    capitalSideRepaymentPlanOther.setCapitalAmount(10000);
					    capitalSideRepaymentPlanOther.setInterest(1000);
					    capitalSideRepaymentPlanOther.setAmount(101000);
					    capitalSideRepaymentPlanOther.setPersonInCharge("lzx");
					    req.addCapitalSideRepaymentPlan(capitalSideRepaymentPlanOther);
					
					    //req.setEnuu(10050877);
					   req.setCapitalSideLoan(capitalSideLoanOther);
					   Master ceuuMaster = ContextHolder.getMaster();
				       //req.setEnuu(Integer.valueOf(ceuuMaster.getMa_uu().toString()));
					   req.setEnuu(10050877);
					 AddCapitalSideLoanResp resp = capitalSideSdk.addCapitalSideLoan(req);
					 System.out.println(resp);
	                String s = ProtoBufUtil.toJSON(resp);
	                JSONObject jsonObject = JSONObject.parseObject(s);
	                Object code = JSONObject.parseObject(jsonObject.get("respHeader").toString()).get("code");
	                if ("0".equals(code.toString())){
	                    sqlList.add("update ACCOUNTAPPLY set AA_UPLOADSTATUS = '已上传' where aa_id = " + map.get("aa_ID"));
	                }
				}
	            if (!CollectionUtils.isEmpty(sqlList)) {
	                jdbcTemplate.batchExecute(sqlList);
	            }
			}
		
		   
		
		  //  AddCapitalSideLoanResp resp = capitalSideSdk.addCapitalSideLoan(req);
		   // System.out.println(ProtoBufUtil.toJSON(resp));
		}
		*/
		/**
		 * 获取需要上传的放款申请
		 *
		 * @return
		 */
	/*private List<Map<String, Object>> getAccountApplyUpload() {
			List<Map<String, Object>> maps = jdbcTemplate.queryForList(" select * from ("
        +" select AA_ID,AA_FINANCEDEMANDCODE,AA_LOANCODE,AA_CSENUU,AA_FSENUU,AA_RECEIVABLESARRIVALDATE,AA_FINANCERATE,AA_LOANAMOUNT,"
        +" AA_LOANRATE,AA_REPAYMENTFREQUENCY,AA_FSCOLLECTIONBANK,AA_FSCOLLECTIONACCOUNT,AA_FSCOLLECTIONNAME,AA_RECEIPTFORLOAN,AA_INTERESTPAYABLE,"
        +" AA_BEOVERDUE,AA_SETTLE,AA_PERSONINCHARGE,AA_APPROVALDATE,AA_APPROVALMAN,AA_BACKDATE,AA_APPLYDATE,AA_B2BSTATUS from ACCOUNTAPPLY "
        +" where AA_UPLOADSTATUS = '待上传' order by aa_code) where rownum < 100");
			System.out.println(maps);
		 return maps;
		}*/

	/**
	 * 上传卖方客户额度申请
	 * @throws Exception
	 */
	@TaskMapping(title = "上传卖方客户额度申请", fixedDelay = 30000, method = Method.UPLOAD)
	public void saveOfferQuotaInfoReq() throws Exception{
		List<Map<String, Object>> customerQuotaUpload = getCustomerQuotaUpload();
		if (!CollectionUtils.isEmpty(customerQuotaUpload)) {
            List<String> sqlList = new ArrayList<>();
			for (Map<String, Object> map:customerQuotaUpload) {
                //资金方UU
                Object cq_factoruu = map.get("CQ_FACTORUU");
                Integer cqFactoruu =10050877;
                //Integer cqFactoruu =10046945; //线上
                if (cq_factoruu!=null) {
                   cqFactoruu = Integer.valueOf(cq_factoruu.toString());
                }

			    //融资方UU
                Object cq_custuu = map.get("CQ_CUSTUU");
                Integer cqCustuu =0;
                if (cq_custuu!=null) {
                    cqCustuu = Integer.valueOf(cq_custuu.toString());
                }
                //融资方企业名称
                String cqCustname = map.get("CQ_CUSTNAME").toString();
                //授信期限(月)
                Integer cqEffectdays = Integer.valueOf(map.get("CQ_EFFECTDAYS").toString());
			    //当前额度
                Double cqQuota = Double.valueOf(map.get("CQ_QUOTA").toString())/10000;
                //融资比例
                Double cqLendrate = Double.valueOf(map.get("CQ_LENDRATE").toString());
                //年化利率
                Double cqAnnualrate = Double.valueOf(map.get("CQ_ANNUALRATE").toString());
                //还款方式
                String cqRepaymentmeans = map.get("CQ_REPAYMENTMEANS").toString();
                //录入人UU
                Object cq_recorderuu = map.get("CQ_RECORDERUU");
                Integer cqRecorderuu =200040254;
                //Integer cqRecorderuu =1000014617;  // 线上
				if (cq_recorderuu!=null) {
					cqRecorderuu = Integer.valueOf(cq_recorderuu.toString());
				}
				//审核结果
				Object cq_approval = map.get("CQ_APPROVAL");
				Integer cqApproval=1403;
				if (Integer.valueOf(cq_approval.toString())==1){
					cqApproval=1402;
				}
				//到期时间
				SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				Object cq_enddate = map.get("CQ_ENDDATE");
				String cqEnddate = format.format(new Date());
				if (cq_enddate!=null){
					cqEnddate = format.format(new Date(Long.valueOf(cq_enddate.toString())));
				}
				//基本面评价
				Object cq_basicevaluation = map.get("CQ_BASICEVALUATION");
				String cqBasicevaluation = "";
				if (cq_basicevaluation!=null){
					cqBasicevaluation = cq_basicevaluation.toString();
				}


				SaveOfferQuotaInfoReq.Builder req = SaveOfferQuotaInfoReq.newBuilder();
				req.setCsEnuu(cqFactoruu).setCsEnName("深圳市英唐保理有限公司").setFsEnuu(cqCustuu).setFsEnName(cqCustname).setQuotaAmount(cqQuota)
						.setCredDays(cqEffectdays).setFinanceRate(cqLendrate).setOfferRate(cqAnnualrate).setRepayment(
                        cqRepaymentmeans).setApplyUu(cqRecorderuu);
				SaveOfferQuotaInfoResp resp = capitalSideSdk.saveOfferQuotaInfo(req);
                String s = ProtoBufUtil.toJSON(resp);
                JSONObject jsonObject = JSONObject.parseObject(s);
                Object code = JSONObject.parseObject(jsonObject.get("respHeader").toString()).get("code");
				Object msg = JSONObject.parseObject(jsonObject.get("respHeader").toString()).get("msg");
                if ("0".equals(code.toString())||(msg!=null&&"您已经为该企业申请过报价额度，请不要重复申请".equals(msg.toString()))){
					UpdateOfferQuotaInfoReq.Builder builder = UpdateOfferQuotaInfoReq.newBuilder();
					builder.setCsEnuu(cqFactoruu).setFsEnuu(cqCustuu).setStatus(cqApproval).setEndTime(cqEnddate)
							.setCheckerContent(cqBasicevaluation).setCheckUu(cqRecorderuu);
					UpdateOfferQuotaInfoResp infoResp = capitalSideSdk.updateOfferQuotaInfo(builder);
					String ss = ProtoBufUtil.toJSON(infoResp);
					JSONObject json = JSONObject.parseObject(ss);
					Object code1 = JSONObject.parseObject(json.get("respHeader").toString()).get("code");
					if ("0".equals(code1.toString())) {
						sqlList.add("update customerQuota set CQ_UPLOADSTATUS = '已上传' where cq_id = " + map.get("CQ_ID"));
					}
                }
			}
            if (!CollectionUtils.isEmpty(sqlList)) {
                jdbcTemplate.batchExecute(sqlList);
            }
		}
	}

	/**
	 * 获取需要上传的卖方客户额度申请
	 *
	 * @return
	 */
	private List<Map<String, Object>> getCustomerQuotaUpload() {
		List<Map<String, Object>> maps = jdbcTemplate.queryForList("select * from (select cq_id,cq_factoruu," +
                "cq_custuu,cq_custname,cq_effectdays,cq_quota,cq_lendrate,cq_annualrate," +
                "cq_repaymentmeans,cq_recorderuu,cq_approval,cq_enddate,cq_basicevaluation from " +
                "customerQuota where " +
				"CQ_UPLOADSTATUS='待上传' and cq_status = '已审核' and cq_quotatype='卖方客户' order by cq_code ) where rownum " +
                "< 100");
		return maps;
	}
	/**
     * 报价记录下载
     * @throws Exception
     */
	/*@TaskMapping(title = "报价记录下载", fixedDelay = 30000, method = Method.DOWNLOAD)
    public void getFinanceOfferList() throws Exception {
    	final List<String> sqls = new ArrayList<>();
    	final List<String> sqlsDemand = new ArrayList<>();
    	final List<String> sqlloand = new ArrayList<>();
    	GetFinanceOfferListReq.Builder req = GetFinanceOfferListReq.newBuilder();
    	Master ceuuMaster = ContextHolder.getMaster();
        //req.setEnuu(Integer.valueOf(ceuuMaster.getMa_uu().toString()));
    	req.setEnuu(10050877);
		req.setPageNumber(1);
		req.setPageSize(100);
		Calendar beforeTime = Calendar.getInstance();
		beforeTime.add(Calendar.MINUTE, -7);// 7分钟之前的时间
		Date beforeD = beforeTime.getTime();
		req.setUpdateTime(beforeD.getTime());//获取最近7分钟更新的单据列表
		GetFinanceOfferListResp resp = capitalSideSdk.getFinanceOfferList(req);
		List<? extends FinanceOfferListOrBuilder> flist = resp.getFinanceOfferInfoOrBuilderList();
		for(FinanceOfferListOrBuilder Finance :flist){
			//System.out.println("从表1："+Finance.toString());
			sqls.add("MERGE INTO AcceptOffer ao"
			+" USING (SELECT nvl(max(id),0) ID FROM AcceptOffer where CODE = '"+Finance.getAcceptOfferInfo().getCode()+"') b"
		    +" ON (ao.ID = b.ID)"
		    +" WHEN MATCHED THEN "
		    +" UPDATE SET ao.STATUS = '"+Finance.getAcceptOfferInfo().getStatus()+"' "
		    +" WHEN NOT MATCHED THEN"
		    +" INSERT (ID,CODE,FINANCECODE,OFFERAMOUNT,FINANCERATE,FINANCEDAYS,CAPITALSIDENAME,CSCONTACTSMAN,CSCONTACTSPHONE,CSENUU,"
		    +" CSUSERUU,CSUSERNAME,FINANCESIDENAME,FSCONTACTSMAN,FSCONTACTSPHONE,OFFERTIME,STATUS,PAYMENTS,OFFERRATE,FINANCINGRATIO,UPLOADSTATUS)"
		    + " values (AcceptOffer_seq.nextval,'"+Finance.getAcceptOfferInfo().getCode()+"','"+Finance.getAcceptOfferInfo().getFinanceCode()+"','"+Finance.getAcceptOfferInfo().getOfferAmount()+"',"
				+ "'"+Finance.getAcceptOfferInfo().getOfferRate() * 100+"','"+Finance.getAcceptOfferInfo().getFinanceDays()+"','"+Finance.getAcceptOfferInfo().getCapitalSideName()+"','"+Finance.getAcceptOfferInfo().getCsContactsMan()+"',"
			    + "'"+Finance.getAcceptOfferInfo().getCsContactsPhone()+"','"+Finance.getAcceptOfferInfo().getCsEnuu()+"','"+Finance.getAcceptOfferInfo().getCsUseruu()+"','"+Finance.getAcceptOfferInfo().getCsUserName()+"',"
			    + "'"+Finance.getAcceptOfferInfo().getFinanceSideName()+"','"+Finance.getAcceptOfferInfo().getFsContactsMan()+"','"+Finance.getAcceptOfferInfo().getFsContactsPhone()+"','"+Finance.getAcceptOfferInfo().getOfferTime()+"',"
			    + "'"+Finance.getAcceptOfferInfo().getStatus()+"','"+Finance.getAcceptOfferInfo().getPayments()+"','"+Finance.getAcceptOfferInfo().getFinanceRate()+"',"
			    + "'"+Finance.getAcceptOfferInfo().getOfferRate() * 100+"','已上传')");
			//融资需求
			sqlsDemand.add("MERGE INTO ACCEPTFINANCEDEMAND a"
				    +" USING (SELECT nvl(max(id),0) ID from ACCEPTFINANCEDEMAND where code = '"+Finance.getFinanceDemandInfo().getCode()+"') b"
				    +" ON (a.ID = b.ID)"
				    +" WHEN MATCHED THEN "
				    +" UPDATE SET a.AMOUNT='"+Finance.getFinanceDemandInfo().getAmount()+"',a.DEALAMOUNT = '"+Finance.getFinanceDemandInfo().getDealAmount()+"',a.DEALRATE = '"+Finance.getFinanceDemandInfo().getDealRate()+"',"
				    		+ "a.FSENNAME = '"+Finance.getFinanceDemandInfo().getFsEnName()+"',a.status = '"+Finance.getFinanceDemandInfo().getStatus()+"',a.FSCONTACTSPHONE = '"+Finance.getFinanceDemandInfo().getFsContactsPhone()+"',"
				    		+ "a.PUBTIME = '"+Finance.getFinanceDemandInfo().getPubTime()+"',a.ENDTIME = '"+Finance.getFinanceDemandInfo().getEndTime()+"',"
				    		+ "a.DEALTIME ='"+Finance.getFinanceDemandInfo().getDealTime()+"',a.OFFERCOUNT ='"+Finance.getFinanceDemandInfo().getOfferCount()+"',a.FSDEMANDAMOUNT = '"+Finance.getFinanceDemandInfo().getFsDemandAmount()+"'"
				    +" WHEN NOT MATCHED THEN "
				    +" INSERT (ID,CODE,ADOPTCODE,FINANCEDAYS,STATUS,AMOUNT,DEALAMOUNT,DEALRATE,FSENNAME,FSENUU,FSUSERNAME,FSUSERUU,FSCONTACTSMAN,"
				    + "FSCONTACTSPHONE,CSENNAME,CSENUU,CSUSERNAME,CSUSERUU,CSCONTACTSMAN,CSCONTACTSPHONE,PUBTIME,ENDTIME,DEALTIME,OFFERCOUNT,FSDEMANDAMOUNT,UPLOADSTATUS)"
    			+ " values (ACCEPTFINANCEDEMAND_seq.nextval,'"+Finance.getFinanceDemandInfo().getCode()+"','"+Finance.getFinanceDemandInfo().getAdoptCode()+"','"+Finance.getFinanceDemandInfo().getFinanceDays()+"',"
    					+ "'"+Finance.getFinanceDemandInfo().getStatus()+"','"+Finance.getFinanceDemandInfo().getAmount()+"','"+Finance.getFinanceDemandInfo().getDealAmount()+"','"+Finance.getFinanceDemandInfo().getDealRate()+"',"
    				    + "'"+Finance.getFinanceDemandInfo().getFsEnName()+"','"+Finance.getFinanceDemandInfo().getFsEnuu()+"','"+Finance.getFinanceDemandInfo().getFsUserName()+"','"+Finance.getFinanceDemandInfo().getFsUseruu()+"',"
    				    + "'"+Finance.getFinanceDemandInfo().getFsContactsMan()+"','"+Finance.getFinanceDemandInfo().getFsContactsPhone()+"','"+Finance.getFinanceDemandInfo().getCsEnName()+"','"+Finance.getFinanceDemandInfo().getCsEnuu()+"',"
    				    + "'"+Finance.getFinanceDemandInfo().getCsUserName()+"','"+Finance.getFinanceDemandInfo().getCsUseruu()+"','"+Finance.getFinanceDemandInfo().getCsContactsMan()+"',"
    				    + "'"+Finance.getFinanceDemandInfo().getCsContactsPhone()+"','"+Finance.getFinanceDemandInfo().getPubTime()+"','"+Finance.getFinanceDemandInfo().getEndTime()+"'"
    				    + ",'"+Finance.getFinanceDemandInfo().getDealTime()+"','"+Finance.getFinanceDemandInfo().getOfferCount()+"','"+Finance.getFinanceDemandInfo().getFsDemandAmount()+"'"
    				    + ",'已上传')");
			sqls.addAll(getFinanceOfferDetailsSqls(Finance.getAcceptOfferInfo().getCode()));
			
			//放款记录
			if(Finance.getAcceptOfferInfo().getStatus() == 1002){
 				String aaCode = jdbcTemplate.generateCode("AccountApply!YSB2", 2);
				sqlloand.add("MERGE INTO AccountApply a"
					    +" USING (SELECT nvl(max(AA_ID),0) ID from AccountApply where AA_FINANCEDEMANDCODE = '"+Finance.getFinanceDemandInfo().getCode()+"') b"
					    +" ON (a.AA_ID = b.ID)"
					    +" WHEN MATCHED THEN "
					    +" UPDATE SET a.AA_CUSTNAME ='"+Finance.getFinanceDemandInfo().getCsUserName()+"'"
					    +" WHEN NOT MATCHED THEN "
                        +" INSERT(AA_ID, AA_CODE, AA_CUSTCODE, AA_CUSTNAME, AA_STATUS, AA_SACODES, AA_BILLCODES,"
	        			+ " AA_BILLAMOUNT, AA_CURRENCY, AA_DUEAMOUNT, AA_BANK, AA_BACKBANKNO, AA_LOANDATE, AA_BACKDATE, "
	        			+ "AA_INTERESTRATE, AA_PENALTYRATE, AA_LENDRATE, AA_EFFECTDAYS, AA_HANDRATE, AA_OTHRATE, AA_ISNOTARIZATION,"
	        			+ " AA_OTHERS, AA_REMARK, AA_TRUSTER, AA_APPLYDATE, AA_RECORDER, AA_INDATE, AA_AUDITMAN, AA_AUDITDATE, "
	        			+ "AA_STATUSCODE, AA_ISPENALTY, AA_CACODE, AA_INTERESTPAYMETHOD, AA_FACTORING, AA_HAND, AA_MATURITYDATE, "
	        			+ "AA_LEFTAMOUNT, AA_INTERESTPAY, AA_AHEADPOUNDAGE, AA_OVERDUEDAYS, AA_ISCLOSEOFF, AA_CATECODE, AA_CATEDESC,"
	        			+ " AA_ISOVERDUE, AA_ODCODE, AA_INTEREST, AA_ARID, AA_ARCODE, AA_SAAMOUNT, AA_THISPAYAMOUNT, AA_THISPAYDATE, "
	        			+ "AA_TURNSTATUS, AA_TURNSTATUSCODE, AA_YAMOUNT, AA_MFCUSTCODE, AA_MFCUSTNAME, AA_TRANSFERAMOUNT, AA_ACTPAYDATE,"
	        			+ " AA_DOWNPAY, AA_DOWNPAYDESC, AA_MARGIN, AA_MARGINAMOUNT, AA_MARGINDATE, AA_GRACEPERIOD, AA_GRACEDAYS, "
	        			+ "AA_GRACERATE, AA_ASSUREMEANS, AA_CUSTACCOUNT, AA_LIVEYEAR, AA_AAID, AA_PRODUCTTYPE, AA_CLASS, AA_WANTAMOUNT, "
	        			+ "AA_FACTORCODE, AA_FACTORNAME, AA_LASTUPDATEDATE, AA_FIRSTDATE, AA_DEBXDATE, AA_DEBJDATE, AA_SENDSTATUS, " 
	        			+ "AA_B2BCODE, AA_AGREE, AA_MATURITY, AA_FINANCEDEMANDCODE, AA_ACCEPTOFFERCODE, AA_LOANCODE, AA_CSENUU, "
	        			+ "AA_FSENUU, AA_FSNAME, AA_RECEIVABLESARRIVALDATE, AA_FINANCERATE, AA_LOANAMOUNT, AA_LOANRATE, "
	        			+ "AA_REPAYMENTFREQUENCY, AA_FSCOLLECTIONBANK, AA_FSCOLLECTIONACCOUNT, AA_FSCOLLECTIONNAME, "
	        			+ "AA_RECEIPTFORLOAN, AA_INTERESTPAYABLE, AA_BEOVERDUE, AA_SETTLE, AA_PERSONINCHARGE, AA_APPROVALDATE, "
	        			+ "AA_APPROVALMAN, AA_UPLOADSTATUS,AA_B2BSTATUS,AA_REPAYMENTDATA,AA_B2BAA_APPLYDATE,AA_B2BAA_AUDITDATE) "
					    
					    + "values (AccountApply_seq.nextval,'"+aaCode+"',null,null,'在录入',null,null,null,' ',null,null,null,null,null,'"+Finance.getAcceptOfferInfo().getOfferRate() * 100+"',null,'"+Finance.getAcceptOfferInfo().getFinancingRatio()+"',null,null,null,null,null,null"
    			        + ",'"+Finance.getFinanceDemandInfo().getCsUserName()+"',sysdate,null,sysdate,null,null,'ENTERING',null,null,null,null,null"
    				    + ",null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null"
    					+ ",null,null,null,null,null,null,null,null,null,null,null,null,null,null,'"+Finance.getFinanceDemandInfo().getCode()+"','"+Finance.getAcceptOfferInfo().getCode()+"',"
    					+ "'"+aaCode+"','"+Finance.getAcceptOfferInfo().getCsEnuu()+"','"+Finance.getFinanceDemandInfo().getFsEnuu()+"','"+Finance.getFinanceDemandInfo().getFsEnName()+"',"
    				    + "null,'"+Finance.getAcceptOfferInfo().getFinancingRatio() * 100+"',null,"
    				    + "'"+Finance.getAcceptOfferInfo().getOfferRate() * 100+"','"+Finance.getAcceptOfferInfo().getPayments()+"',null,"
    				    + "null,null,null,null,"
    				    + "null,null,'"+Finance.getFinanceDemandInfo().getCsUserName()+"',null,null,'已上传',"
    				    + "'"+Finance.getAcceptOfferInfo().getStatus()+"',null,null,null)");
			}
		}
        jdbcTemplate.batchExecute(sqls);  //报价信息
        jdbcTemplate.batchExecute(sqlsDemand);   //融资信息
        System.out.println(sqlloand);
        jdbcTemplate.batchExecute(sqlloand);   //放款信息
	}
	//报价详情
    public List<String> getFinanceOfferDetailsSqls(String OfferCode) throws Exception{
	List<String> sqls = new ArrayList<String>();
	GetFinanceOfferDetailsReq.Builder req = GetFinanceOfferDetailsReq.newBuilder();
	//System.out.println("OfferCode："+OfferCode);
	req.setOfferCode(OfferCode);
	GetFinanceOfferDetailsResp resp = capitalSideSdk.getFinanceOfferDetails(req);
	FinanceOfferDetails adetaillist =  resp.getFinanceOfferInfo();
	List<OfferDetailAndFinanceAccept> restlist = adetaillist.getOfferDetailAndFinanceAcceptInfoList();
	//System.out.println("从表1："+restlist.size());
	//System.out.println("从表1："+restlist.toString());
	for(OfferDetailAndFinanceAccept rest :restlist){
		//报价明细
		int offerDetailCount = jdbcTemplate.count(" from acceptOfferDetail where acceptOfferCode =?",OfferCode);
		//System.out.println("acceptOfferDetail："+offerDetailCount);
		if(offerDetailCount == 0){
			AcceptOfferDetail acceptOfferDetail = rest.getAcceptOfferDetail();
			sqls.add("insert into acceptOfferDetail(id_,MIANcode,acceptOfferCode,financeDemandDetailCode,financeDemandDetailAcceptCode,offerAmount) "
					+ "values (acceptOfferDetail_seq.nextval,'"+acceptOfferDetail.getCode()+"','"+acceptOfferDetail.getAcceptOfferCode()+"',"
					+ "'"+acceptOfferDetail.getFinanceDemandDetailCode()+"','"+acceptOfferDetail.getFinanceDemandDetailAcceptCode()+"'"
					+ ",'"+acceptOfferDetail.getOfferAmount()+"')");
		}
		//融资需求与B2B订单信息
		int accepDetailCount = jdbcTemplate.count(" from ACCEPTFINANCEDEMANDDETAIL where FINANCEDEMANDCODE =?",rest.getFinanceDemandDetail().getFinanceDemandCode());
		//System.out.println("ACCEPTFINANCEDEMANDDETAIL："+accepDetailCount);
		if(accepDetailCount == 0){
			sqls.add("insert into ACCEPTFINANCEDEMANDDETAIL(ID,CODE,FINANCEDEMANDCODE,CUSTENUU,CUSTENNAME,CUSTGRADE,PAYMENTS,ORDERID,ORDERCODE,ORDERTOTAL,"
					+ "ACCEPTAMOUNT,UPLOADSTATUS) "
					+ "values (ACCEPTFINANCEDEMANDDETAIL_seq.nextval,'"+rest.getFinanceDemandDetail().getCode()+"','"+rest.getFinanceDemandDetail().getFinanceDemandCode()+"','"+rest.getFinanceDemandDetail().getCustEnuu()+"',"
					+ "'"+rest.getFinanceDemandDetail().getCustEnName()+"','"+rest.getFinanceDemandDetail().getCustGrade()+"','"+rest.getFinanceDemandDetail().getPayments()+"','"+rest.getFinanceDemandDetail().getOrderId()+"',"
					+ "'"+rest.getFinanceDemandDetail().getOrderCode()+"','"+rest.getFinanceDemandDetail().getOrderTotal()+"','"+rest.getFinanceDemandDetail().getAcceptAmount()+"','已上传')");
		}
		 //融资需求与B2B验收单信息单详情
		int accepDetCount = jdbcTemplate.count(" from FINANCEDEMANDDETAILACCEPT where FINANCEDEMANDCODE =?",rest.getFinanceDemandDetailAccept().getFinanceDemandCode());
		//System.out.println("FINANCEDEMANDDETAILACCEPT："+accepDetCount);
		if(accepDetCount == 0){
			sqls.add("insert into FINANCEDEMANDDETAILACCEPT(ID,CODE,FINANCEDEMANDCODE,FINANCEDEMANDDETAILCODE,ORDERITEMID,ACCEPTITEMID,ACCEPTID,ACCEPTAMOUNT,ACCEPTDATE,ACCEPTCODE,"
        			+ "ACCEPTSTATUS,TITLE,SPEC,PRODUCTCODE,STATUS,UPLOADSTATUS) "
        			+ "values (FINANCEDEMANDDETAILACCEPT_seq.nextval,'"+rest.getFinanceDemandDetailAccept().getCode()+"','"+rest.getFinanceDemandDetailAccept().getFinanceDemandCode()+"','"+rest.getFinanceDemandDetailAccept().getFinanceDemandDetailCode()+"',"
        			+ "'"+rest.getFinanceDemandDetailAccept().getOrderItemId()+"','"+rest.getFinanceDemandDetailAccept().getAcceptItemId()+"','"+rest.getFinanceDemandDetailAccept().getAcceptId()+"','"+rest.getFinanceDemandDetailAccept().getAcceptAmount()+"',"
        					+ "( ("+rest.getFinanceDemandDetailAccept().getAcceptDate()+"/(1000*60*60*24)) + to_date('19700101 08:00:00','yyyymmdd hh24:mi:ss') ),"
        		    + "'"+rest.getFinanceDemandDetailAccept().getAcceptCode()+"','"+rest.getFinanceDemandDetailAccept().getAcceptStatus()+"',"
        		    + "'"+rest.getFinanceDemandDetailAccept().getTitle()+"','"+rest.getFinanceDemandDetailAccept().getSpec()+"',"
        		    + "'"+rest.getFinanceDemandDetailAccept().getProductCode()+"','"+rest.getFinanceDemandDetailAccept().getStatus()+"','已上传')");
		}
	}
	return sqls;
}*/
}

